@Filename: AdcRd.s
@Part: ADuC702x.
@Created: 15/04/2004
@Updated: 28/06/2005
@Author: Eckart Hartmann.
@This file is in beta sampling.

.include        "ADuC7020.equ"
.ARM

@ AdcRd==========Reads the ADC data.
@ C Function prototype: int AdcRd(void);
@ Description of Function: Reads the ADC data.
@ User interface:
@       Call AdcRd.
@       Returns ADCDAT with 0x0fffffff representing full scale (VRef).
@ Robustness:  
@     In differential mode the data format is corrected to 
@     be a signed int with 0x0fffffff representing VRef),
@     0x00000000 representing 0V 
@     and 0xf0000000 representing -VRef.
@ Side effects: 
@     Corrupts r1 and r3.
@     Clears ADCSTA.0.

.GLOBAL AdcRd
AdcRd:
        mov     r3,#0xff0000            @r3 = Z_BASE;
        orr     r3,r3,#0xff000000
        ldr     r0,[r3,#ADCDAT_OFFSET]  @Get ADCDAT.
        ldr     r1,[r3,#ADCCON_OFFSET]
        ands    r1,r1,#8                @if(differential)
        movne   r0,r0,ASL#4             @ fix format.
        movne   r0,r0,ASR#3
        bx      lr                      @return.
